<template>
  <div v-if="isVisible">
    <v-card :loading="isLoadingDistribucionCumplimientoPuntajeCecos">
      <IdGrafico id="016" />
      <div class="gris">
        <img :src="imagenNegocio" style="width: 80px;" />
        <h2 class="tituloBloque">
          Distribución del cumplimiento por nivel
          <span
            v-if="
              globalFilters &&
                globalFilters.filters.nivel_geografico.descripcion
            "
            class="bold keep-spaces"
            >{{
              " " + globalFilters.filters.nivel_geografico.descripcion
            }}</span
          >
        </h2>
        <div class="divCumplimiento">
          <div>
            <v-radio-group style="float:right" v-model="isPersentValue">
              <v-radio
                color="primary"
                label="Porcentaje (%)"
                :value="true"
              ></v-radio>
              <v-radio
                color="primary"
                label="Puntos de contacto"
                :value="false"
              ></v-radio>
            </v-radio-group>
          </div>
          <div
            style="display: flex;width: 98%;margin: 0 auto 10px auto;"
            class="contenedorBarra"
            v-for="(itemCecoDisciplina,
            indexItemCecoDisciplina) in cecosDisciplina.cecos"
            :key="indexItemCecoDisciplina"
          >
            <div>
              <div :style="{ width: widthCecoColumn + 'px' }">
                <a @click="zoomSearchCeco(itemCecoDisciplina)" class="liga">{{
                  itemCecoDisciplina.descripcion
                }}</a>
              </div>
              <div class="barra tBold">
                <template
                  v-for="(itemRangoNegocio,
                  indexItemRangoNegocio) in itemCecoDisciplina.rangos"
                >
                  <div
                    :key="indexItemRangoNegocio"
                    v-bind:style="{
                      width: itemRangoNegocio.width + '%',
                      backgroundColor: itemRangoNegocio.rango.detalle
                    }"
                    class="text-center"
                  >
                    <template v-if="isPersentValue">
                      {{ itemRangoNegocio.calificacion }}%
                    </template>
                    <template v-else>
                      {{ itemRangoNegocio.puntos_contacto }}
                    </template>
                  </div>
                </template>
              </div>
            </div>
          </div>
        </div>
      </div>
    </v-card>
  </div>
</template>
<style scoped>
a.liga {
  color: #000000 !important;
  text-decoration: underline;
  font-family: "AvenirNextLTPro-Medium";
  cursor: pointer;
}
.divCumplimiento {
  width: 100%;
  margin: 0 auto;
  border: 1px solid #bfbfbf;
  padding-top: 10px;
}
.barra {
  width: 100%;
  display: flex;
  color: white;
  background-color: grey;
}
.barra > div {
  height: 23px;
  display: flex;
  align-items: center;
  padding-left: 6px;
}
.contenedorBarra > div:nth-child(1) {
  display: flex;
  width: 100%;
  align-items: center;
}
.contenedorBarra > div:nth-child(2) {
  display: flex;
  width: 100%;
  align-items: center;
}
</style>
<script>
import store from "@/store";
import axios from "axios";
import IdGrafico from "@/views/secure/sistema-informacion/dashboards/commons/IdGraficoLabel.vue";
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-DistribucionCumplimientoCecoNegocioPorNivel",
  props: {
    methodsSemaforoParent: Object,
    globalFiltersParent: Object
  },
  components: {
    IdGrafico
  },
  data() {
    return {
      isLoadingDistribucionCumplimientoPuntajeCecos: true,
      isPersentValue: true,
      methodsSemaforo: null,
      globalFilters: null,
      cecosDisciplina: {},
      widthCecoColumn: 120,
      originalFilters: null,
      isVisible: true,
      zoomSearchCeco: null
    };
  },
  computed: {
    imagenNegocio() {
      if (this.globalFilters && this.globalFilters.final_filters) {
        const img = serviceCommons.getLogoImageByIdNegocio(
          this.globalFilters.final_filters.id_negocio
        );
        return img;
      }
      return "";
    }
  },
  methods: {
    listenSearchConsulta(globalFilters, originalFilters, zoomSearchCeco) {
      if (
        globalFilters.final_filters.nivel_geografico > 1 &&
        globalFilters.final_filters.id_negocio > 0 &&
        globalFilters.final_filters.id_disciplina == 5
      ) {
        this.isVisible = true;
        this.globalFilters = globalFilters;
        this.originalFilters = originalFilters;
        this.zoomSearchCeco = zoomSearchCeco;
        this.getDistribucionCumplimientoCecos();
      } else {
        this.isVisible = false;
      }
    },
    listenSemaforo(methodsSemaforo) {
      this.methodsSemaforo = methodsSemaforo;
    },
    getDistribucionCumplimientoCecos() {
      this.isLoadingDistribucionCumplimientoPuntajeCecos = true;
      const self = this;
      const contentFiltros = {
        filtros: this.globalFilters.final_filters
      };
      axios
        .post(
          "franquicia/dashboard/secure/grafico/get/distribucion/cumplimiento/ceco/negocio/nivel",
          contentFiltros
        )
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setDistribucionCumplimientoCecos(data);
              }
            } else {
              self.setDistribucionCumplimientoCecos([]);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isLoadingDistribucionCumplimientoPuntajeCecos = false;
        });
    },
    setDistribucionCumplimientoCecos(cecosDisciplina) {
      const self = this;
      if (cecosDisciplina.cecos) {
        cecosDisciplina.cecos.forEach((itemCeco) => {
          itemCeco.descripcion =
            itemCeco.id_ceco + " - " + itemCeco.descripcion;
          let sumRango = 0;
          itemCeco.rangos.forEach((itemRango) => {
            sumRango += itemRango.calificacion;
            itemRango.width = itemRango.calificacion;
            if (
              self.methodsSemaforo &&
              self.methodsSemaforo.getRangoByLimit(itemRango.calificacion)
            ) {
              let rango = self.methodsSemaforo.getRangoByLimit(itemRango.calificacion);
              itemRango.rango = {
                detalle: rango.detalle
              };
            } else {
              itemRango.rango = {
                detalle: ""
              };
            }
            if (sumRango < 100) {
              let rango = itemCeco.rangos.reduce(function(prev, current) {
                return prev.calificacion < current.calificacion
                  ? prev
                  : current;
              });
              rango.width = 100 - sumRango + rango.calificacion;
            }
          });
        });
      }
      if (cecosDisciplina.cecos && cecosDisciplina.cecos.length > 0) {
        let cecoLargeName = cecosDisciplina.cecos.reduce(function(
          prev,
          current
        ) {
          let descripcionPrev = 0;
          if (prev && prev.descripcion) {
            descripcionPrev = prev.descripcion.length;
          }
          const descripcionCurrent = current.descripcion.length
            ? 0
            : current.descripcion.length;
          return descripcionPrev > descripcionCurrent ? prev : current;
        });
        if (typeof cecoLargeName === "object") {
          cecoLargeName = cecoLargeName.descripcion.length;
        }
        this.widthCecoColumn = cecoLargeName * 12;
      }
      this.cecosDisciplina = cecosDisciplina;
    }
  },
  mounted() {
    this.$root.$on("searchconsulta", this.listenSearchConsulta);
    this.$root.$on("rangoloaded", this.listenSemaforo);
  },
  created() {
    this.methodsSemaforo = this.methodsSemaforoParent;
    this.globalFilters = this.globalFiltersParent;
    if (this.globalFilters) {
      this.getDistribucionCumplimientoCecos();
    }
  }
};
</script>
